> ## Documentation Index > Fetch the complete documentation index at: https://docs.validatar.com/llms.txt > Use this file to discover all available pages before exploring further. # Create Data Source > Create a new data source ## OpenAPI ````json POST /api/v1/Authoring/data-source { "openapi": "3.0.4", "info": { "title": "Validatar API Documentation", "description": "# Overview\nThe Validatar Core website provides [REST](https://en.wikipedia.org/wiki/Representational_state_transfer) API access to the back-end functionality included in Validatar. This documentation provides the ability to call the API endpoints directly, provided a user is authorized to do so. If you do not currently have the Validatar app, visit the [Validatar home page](https://www.validatar.com/) to see details. If you are looking for the application documentation, visit the [Validatar application documentation page](https://docs.validatar.com/docs).\n\n\n\n# Scopes\n| Scope | Description |\n|----------------|-------------|\n| Authoring | The endpoints in Authoring provide configuration and creation operations. This includes operations such as creating folders or updating tests. |\n| Data Steward | The endpoints in Data Steward allow technical, custom, and lineage metadata ingestion at the data source, schema, table, and column levels. |\n| Execution | The endpoints in Execution allow executing standard/template tests or jobs. |\n| Catalog | The endpoints in Catalog allow retrieving technical, custom, and lineage metadata information at the data source, schema, table, and column levels. |\n| Reporting | The endpoints in Reporting allow retrieving a list of reports and executing reports. |\n| Security Admin | The endpoints in Security Admin allow configuring user groups and managing user permissions. |\n\n", "version": "v1" }, "servers": [ { "url": "https://training.cloud.validatar.com/core" } ], "tags": [ { "name": "Authoring" }, { "name": "Catalog" }, { "name": "Data Steward" }, { "name": "Execution" }, { "name": "Reporting" }, { "name": "Security Admin" } ], "paths": { "/api/v1/Authoring/data-source": { "post": { "tags": [ "Authoring" ], "summary": "Create Data Source", "description": "Create a new data source", "requestBody": { "description": "Information about the new data source", "content": { "application/json-patch+json": { "schema": { "$ref": "#/components/schemas/Configuration.Api.Models.v1.AddDataSourceRequest" } }, "application/json": { "schema": { "$ref": "#/components/schemas/Configuration.Api.Models.v1.AddDataSourceRequest" } }, "text/json": { "schema": { "$ref": "#/components/schemas/Configuration.Api.Models.v1.AddDataSourceRequest" } }, "application/*+json": { "schema": { "$ref": "#/components/schemas/Configuration.Api.Models.v1.AddDataSourceRequest" } } } }, "responses": { "200": { "description": "OK", "content": { "application/json": { "schema": { "$ref": "#/components/schemas/Configuration.Api.Models.v1.AddDataSourceResult" } } } }, "400": { "description": "Bad Request", "content": { "application/json": { "schema": { "$ref": "#/components/schemas/Configuration.Api.Models.v1.Common.ErrorListResponse" } } } }, "403": { "description": "Forbidden" } }, "security": [ {} ] } } }, "components": { "schemas": { "Configuration.Api.Models.v1.AddDataSourceRequest": { "title": "AddDataSourceRequest", "required": [ "connection", "environmentId", "name", "permissions", "referenceKey" ], "type": "object", "properties": { "name": { "minLength": 1, "type": "string", "description": "The data source name" }, "referenceKey": { "minLength": 1, "type": "string", "description": "The data source reference key" }, "description": { "type": "string", "description": "The data source description", "nullable": true }, "environmentId": { "type": "integer", "description": "The ID of the data source's environment", "format": "int32" }, "connection": { "$ref": "#/components/schemas/Configuration.Api.Models.v1.DataSourceConnectionAdd" }, "projectIds": { "type": "array", "items": { "type": "integer", "format": "int32" }, "description": "The IDs of the projects allowed to use the data source" }, "permissions": { "type": "array", "items": { "$ref": "#/components/schemas/Common.DataSourcePermission" }, "description": "List of permissions to add to the data source" }, "schemaMetadata": { "$ref": "#/components/schemas/Common.DataSourceSchemaMetadataDetail" }, "customMetadataSources": { "type": "array", "items": { "$ref": "#/components/schemas/Common.DataSourceCustomMetadataProcessDetail" }, "description": "List of custom metadata sources to add to the data source" }, "profileSets": { "type": "array", "items": { "$ref": "#/components/schemas/Common.DataSourceProfileSetDetail" }, "description": "List of profile sets to add to the data source" }, "customProfiles": { "type": "array", "items": { "$ref": "#/components/schemas/Common.DataSourceProfileCustomDetail" }, "description": "List of custom profiles to add to the data source" } }, "additionalProperties": false }, "Configuration.Api.Models.v1.AddDataSourceResult": { "title": "AddDataSourceResult", "type": "object", "properties": { "id": { "type": "integer", "description": "The ID of the added data source", "format": "int32" }, "name": { "type": "string", "description": "The name of the added data source", "nullable": true } }, "additionalProperties": false }, "Configuration.Api.Models.v1.Common.ErrorListResponse": { "title": "ErrorListResponse", "type": "object", "properties": { "errors": { "type": "array", "items": { "type": "string" } } }, "additionalProperties": false }, "Configuration.Api.Models.v1.DataSourceConnectionAdd": { "title": "Connection", "required": [ "configuration", "connectionType", "engineId" ], "type": "object", "properties": { "engineId": { "type": "integer", "description": "The data processing engine ID to use for the connection", "format": "int32" }, "connectionType": { "$ref": "#/components/schemas/Enums.ConnectionType" }, "dataSourceTemplateId": { "type": "integer", "description": "The data source template ID to use for the connection", "format": "int32", "nullable": true }, "dataAgentGroupId": { "type": "integer", "description": "The data agent group ID to use for the connection", "format": "int32", "nullable": true }, "description": { "type": "string", "description": "The connection description", "nullable": true }, "configuration": { "title": "ConnectionConfigurationBase", "oneOf": [ { "$ref": "#/components/schemas/Common.DataSourceConnectionConfigurationDatabase" }, { "$ref": "#/components/schemas/Common.DataSourceConnectionConfigurationScript" }, { "$ref": "#/components/schemas/Common.DataSourceConnectionConfigurationSnowflake" }, { "$ref": "#/components/schemas/Common.DataSourceConnectionConfigurationDatabricks" } ], "description": "The connection's configuration" } }, "additionalProperties": false }, "Common.DataSourcePermission": { "title": "DataSourcePermission", "type": "object", "properties": { "roleSet": { "type": "string", "nullable": true }, "roles": { "type": "array", "items": { "$ref": "#/components/schemas/Enums.DataSourceRole" }, "nullable": true } }, "additionalProperties": false }, "Common.DataSourceSchemaMetadataDetail": { "title": "DataSourceSchemaMetadataDetail", "type": "object", "properties": { "dataSourceScript": { "type": "string", "nullable": true }, "schemaScript": { "type": "string", "nullable": true }, "tableScript": { "type": "string", "nullable": true }, "columnScript": { "type": "string", "nullable": true }, "schedule": { "$ref": "#/components/schemas/Common.ScheduleInfo" } }, "additionalProperties": false }, "Common.DataSourceCustomMetadataProcessDetail": { "title": "DataSourceCustomMetadataProcessDetail", "required": [ "ingestType", "name" ], "type": "object", "properties": { "ingestType": { "$ref": "#/components/schemas/Common.CustomMetaIngestProcessType" }, "sameAsPrimary": { "type": "boolean" }, "name": { "minLength": 1, "type": "string" }, "description": { "type": "string", "nullable": true }, "certifyCustomFieldValues": { "type": "boolean" }, "ignoreMissingMetadata": { "type": "boolean" }, "dataSourceActive": { "type": "boolean" }, "dataSourceSql": { "type": "string", "nullable": true }, "schemaActive": { "type": "boolean" }, "schemaSql": { "type": "string", "nullable": true }, "tableActive": { "type": "boolean" }, "tableSql": { "type": "string", "nullable": true }, "columnActive": { "type": "boolean" }, "columnSql": { "type": "string", "nullable": true }, "schedule": { "$ref": "#/components/schemas/Common.ScheduleInfo" } }, "additionalProperties": false }, "Common.DataSourceProfileSetDetail": { "title": "DataSourceProfileSetDetail", "type": "object", "properties": { "name": { "type": "string", "nullable": true }, "description": { "type": "string", "nullable": true }, "connectionRole": { "$ref": "#/components/schemas/Common.ProfileSetConnectionRole" }, "maxConcurrentQueries": { "type": "integer", "format": "int32" }, "maxProfilesPerQuery": { "type": "integer", "format": "int32" }, "purgeResults": { "type": "boolean" }, "purgeResultsAfterDays": { "type": "integer", "format": "int32", "nullable": true }, "selectedProfileDefs": { "type": "array", "items": { "type": "string" } }, "metadataFilters": { "type": "array", "items": { "$ref": "#/components/schemas/Common.MetaObjectTechnicalProfileSetFilter" } }, "customFilters": { "type": "array", "items": { "$ref": "#/components/schemas/Common.MetaObjectCustomProfileSetFilter" } }, "schedule": { "$ref": "#/components/schemas/Common.ScheduleInfo" }, "profileScriptKey": { "type": "string", "nullable": true } }, "additionalProperties": false }, "Common.DataSourceProfileCustomDetail": { "title": "DataSourceProfileCustomDetail", "required": [ "format", "formulaType", "level", "name", "referenceKey" ], "type": "object", "properties": { "name": { "minLength": 1, "type": "string" }, "referenceKey": { "minLength": 1, "type": "string" }, "description": { "type": "string", "nullable": true }, "level": { "$ref": "#/components/schemas/Enums.DataProfileLevel" }, "format": { "$ref": "#/components/schemas/Enums.DataProfileFormat" }, "restrictToDataTypes": { "type": "boolean" }, "formulaType": { "$ref": "#/components/schemas/Enums.DataProfileFormulaType" }, "fromScript": { "type": "string", "nullable": true }, "aggregateScript": { "type": "string", "nullable": true }, "groupingScript": { "type": "string", "nullable": true }, "netFormulaExpression": { "type": "string", "nullable": true }, "pythonFormulaExpression": { "type": "string", "nullable": true }, "conditionExpression": { "type": "string", "nullable": true }, "selectedDataTypes": { "type": "array", "items": { "type": "string" } } }, "additionalProperties": false }, "Enums.ConnectionType": { "title": "ConnectionType", "enum": [ "SqlServer", "OLEDB", "ODBC", "Snowflake", "PostgreSql", "PythonScript", "SnowflakeEngine", "Databricks", "DatabricksEngine" ], "type": "string" }, "Common.DataSourceConnectionConfigurationDatabase": { "title": "DatabaseConfiguration", "type": "object", "properties": { "connectionString": { "type": "string" }, "password": { "type": "string", "nullable": true } }, "additionalProperties": false }, "Common.DataSourceConnectionConfigurationScript": { "title": "ScriptConfiguration", "type": "object", "properties": { "preExecutionScript": { "type": "string", "nullable": true }, "postExecutionScript": { "type": "string", "nullable": true }, "parameters": { "type": "array", "items": { "$ref": "#/components/schemas/Common.DataSourceConnectionParsedParameter" } } }, "additionalProperties": false }, "Common.DataSourceConnectionConfigurationSnowflake": { "title": "SnowflakeConfiguration", "required": [ "databaseName" ], "type": "object", "properties": { "engineType": { "type": "string" }, "databaseName": { "minLength": 1, "type": "string" }, "schemaName": { "type": "string", "nullable": true }, "previewRoleName": { "type": "string", "nullable": true } }, "additionalProperties": false }, "Common.DataSourceConnectionConfigurationDatabricks": { "title": "DatabricksConfiguration", "required": [ "databaseName" ], "type": "object", "properties": { "engineType": { "type": "string" }, "databaseName": { "minLength": 1, "type": "string" }, "schemaName": { "type": "string", "nullable": true } }, "additionalProperties": false }, "Enums.DataSourceRole": { "title": "DataSourceRole", "enum": [ "ViewMetadata", "CreateTests", "RunTests", "ViewTestResults", "RunProfileSets", "ManagePermissions", "ManageConnections", "ManageDataProfiling", "EditMetadata", "ExportTestResults", "ManageTrustScores", "PreviewData" ], "type": "string" }, "Common.ScheduleInfo": { "title": "ScheduleInfo", "required": [ "scheduleRecurrence" ], "type": "object", "properties": { "scheduleId": { "type": "integer", "format": "int32", "nullable": true }, "scheduleRecurrence": { "$ref": "#/components/schemas/Enums.ScheduleRecurrence" }, "monthlyRecurrence": { "$ref": "#/components/schemas/Enums.MonthlyRecurrence" }, "dateStart": { "type": "string", "format": "date-time", "nullable": true }, "dateEnd": { "type": "string", "format": "date-time", "nullable": true }, "monthlyAbsoluteRecurrenceInterval": { "type": "integer", "format": "int32", "nullable": true }, "monthlyRelativeRecurrenceInterval": { "type": "integer", "format": "int32", "nullable": true }, "weeklyRecurrenceInterval": { "type": "integer", "format": "int32", "nullable": true }, "dailyRecurrenceInterval": { "type": "integer", "format": "int32", "nullable": true }, "timeStart": { "type": "string", "format": "date-time", "nullable": true }, "timeEnd": { "type": "string", "format": "date-time", "nullable": true }, "timeOnce": { "type": "string", "format": "date-time", "nullable": true }, "timeIntervalValue": { "type": "integer", "format": "int32", "nullable": true }, "timeIntervalType": { "type": "integer", "format": "int32" }, "daysOfWeek": { "type": "string", "nullable": true }, "dayOfMonth": { "type": "integer", "format": "int32", "nullable": true }, "weekOfMonth": { "type": "integer", "format": "int32", "nullable": true }, "dayOfWeek": { "type": "integer", "format": "int32", "nullable": true }, "timeZoneKey": { "type": "string", "nullable": true } }, "additionalProperties": false }, "Common.CustomMetaIngestProcessType": { "title": "CustomMetaIngestProcessType", "enum": [ "File", "Query" ], "type": "string" }, "Common.ProfileSetConnectionRole": { "title": "ProfileSetConnectionRole", "enum": [ "Primary", "DataProfile" ], "type": "string" }, "Common.MetaObjectTechnicalProfileSetFilter": { "title": "MetaObjectTechnicalProfileSetFilter", "type": "object", "properties": { "field": { "$ref": "#/components/schemas/Common.ProfileSetMetaDataFilterField" } }, "additionalProperties": false }, "Common.MetaObjectCustomProfileSetFilter": { "title": "MetaObjectCustomProfileSetFilter", "type": "object", "properties": { "objectType": { "$ref": "#/components/schemas/Common.ProfileSetCustomFieldObjectType" }, "field": { "type": "string", "nullable": true } }, "additionalProperties": false }, "Enums.DataProfileLevel": { "title": "DataProfileLevel", "enum": [ "Table", "Column" ], "type": "string" }, "Enums.DataProfileFormat": { "title": "DataProfileFormat", "enum": [ "NumericValue", "StringValue", "DateTimeValue", "NumericArray", "StringArray", "DateTimeArray", "PercentValue" ], "type": "string" }, "Enums.DataProfileFormulaType": { "title": "DataProfileFormulaType", "enum": [ "Query", "NetCalculation", "PythonCalculation" ], "type": "string" }, "Common.DataSourceConnectionParsedParameter": { "title": "DataSourceConnectionParsedParameter", "type": "object", "properties": { "id": { "type": "integer", "format": "int32" }, "value": { "type": "string", "nullable": true }, "hasSecretValue": { "type": "boolean" }, "clearValue": { "type": "boolean" }, "resetValue": { "type": "boolean" } }, "additionalProperties": false }, "Enums.ScheduleRecurrence": { "title": "ScheduleRecurrence", "enum": [ "Daily", "Weekly", "Monthly" ], "type": "string" }, "Enums.MonthlyRecurrence": { "title": "MonthlyRecurrence", "enum": [ "Absolute", "Relative" ], "type": "string" }, "Common.ProfileSetMetaDataFilterField": { "title": "ProfileSetMetaDataFilterField", "enum": [ "SchemaName", "TableName", "TableType", "ColumnName", "ColumnDataType", "ColumnMappedType", "ColumnNullable", "ColumnIdentity", "ColumnPrimaryKey", "ColumnMaxLength", "TableRecordCount" ], "type": "string" }, "Common.ProfileSetCustomFieldObjectType": { "title": "ProfileSetCustomFieldObjectType", "enum": [ "Table", "Column", "Schema" ], "type": "string" } } } } ````